gr::dab::peak_detector_fb Class Referenceabstract

Detect the peak of a signal. More...

`#include <peak_detector_fb.h>`

Inheritance diagram for gr::dab::peak_detector_fb:
[legend]

## Public Types

typedef std::shared_ptr< peak_detector_fb > | sptr

## Public Member Functions

virtual void | set_threshold_factor_rise (float thr)=0
| Set the threshold factor value for the rise time.
virtual void | set_threshold_factor_fall (float thr)=0
| Set the threshold factor value for the fall time.
virtual void | set_look_ahead (int look)=0
| Set the look-ahead factor.
virtual void | set_alpha (float alpha)=0
| Set the running average alpha.
virtual float | threshold_factor_rise ()=0
| Get the threshold factor value for the rise time.
virtual float | threshold_factor_fall ()=0
| Get the threshold factor value for the fall time.
virtual int | look_ahead ()=0
| Get the look-ahead factor value.
virtual float | alpha ()=0
| Get the alpha value of the running average.

## Static Public Member Functions

static sptr | make (float threshold_factor_rise=0.25, float threshold_factor_fall=0.40, int look_ahead=10, float alpha=0.001)

## Detailed Description

Detect the peak of a signal.

If a peak is detected, this block outputs a 1, or it outputs 0's.

## Member Typedef Documentation

## sptr

typedef std::shared_ptr<peak_detector_fb> gr::dab::peak_detector_fb::sptr

## Member Function Documentation

## alpha()

virtual float gr::dab::peak_detector_fb::alpha | ( |  | ) |

pure virtual

Get the alpha value of the running average.

Returns
  alpha

Implemented in gr::dab::peak_detector_fb_impl.

Referenced by make(), and set_alpha().

## look_ahead()

virtual int gr::dab::peak_detector_fb::look_ahead | ( |  | ) |

pure virtual

Get the look-ahead factor value.

Returns
  look-ahead factor

Implemented in gr::dab::peak_detector_fb_impl.

Referenced by make().

## make()

sptr gr::dab::peak_detector_fb::make | ( | float | threshold_factor_rise = 0.25,
|  | float | threshold_factor_fall = 0.40,
|  | int | look_ahead = 10,
|  | float | alpha = 0.001 )

static

Make a peak detector block.

Parameters

  threshold_factor_rise | The threshold factor determines when a peak has started. An average of the signal is calculated and when the value of the signal goes over threshold_factor_rise*average, we start looking for a peak.
  threshold_factor_fall | The threshold factor determines when a peak has ended. An average of the signal is calculated and when the value of the signal goes below threshold_factor_fall*average, we stop looking for a peak.
  look_ahead | The look-ahead value is used when the threshold is found to look if there another peak within this step range. If there is a larger value, we set that as the peak and look ahead again. This is continued until the highest point is found with This look-ahead range.
  alpha | The gain value of a moving average filter

References alpha(), look_ahead(), threshold_factor_fall(), and threshold_factor_rise().

## set_alpha()

virtual void gr::dab::peak_detector_fb::set_alpha | ( | float | alpha | ) |

pure virtual

Set the running average alpha.

Parameters

  alpha | new alpha for running average

Implemented in gr::dab::peak_detector_fb_impl.

References alpha().

## set_look_ahead()

virtual void gr::dab::peak_detector_fb::set_look_ahead | ( | int | look | ) |

pure virtual

Set the look-ahead factor.

Parameters

  look | new look-ahead factor

Implemented in gr::dab::peak_detector_fb_impl.

## set_threshold_factor_fall()

virtual void gr::dab::peak_detector_fb::set_threshold_factor_fall | ( | float | thr | ) |

pure virtual

Set the threshold factor value for the fall time.

Parameters

  thr | new threshold factor

Implemented in gr::dab::peak_detector_fb_impl.

## set_threshold_factor_rise()

virtual void gr::dab::peak_detector_fb::set_threshold_factor_rise | ( | float | thr | ) |

pure virtual

Set the threshold factor value for the rise time.

Parameters

  thr | new threshold factor

Implemented in gr::dab::peak_detector_fb_impl.

## threshold_factor_fall()

virtual float gr::dab::peak_detector_fb::threshold_factor_fall | ( |  | ) |

pure virtual

Get the threshold factor value for the fall time.

Returns
  threshold factor

Implemented in gr::dab::peak_detector_fb_impl.

Referenced by make().

## threshold_factor_rise()

virtual float gr::dab::peak_detector_fb::threshold_factor_rise | ( |  | ) |

pure virtual

Get the threshold factor value for the rise time.

Returns
  threshold factor

Implemented in gr::dab::peak_detector_fb_impl.

Referenced by make().

The documentation for this class was generated from the following file:

- peak_detector_fb.h